<?php
/************************************************** 
 *                 Bot Gadu-Gadu                  * 
 ************************************************** 
 * Wersja: 2.0 RC                                 * 
 * Data: 03.06.2011 (18:42)                       * 
 * Autor: Jacek Kowalski (http://jacekk.info)     * 
 *                                                * 
 * Utwor rozprowadzany na licencji                * 
 * http://creativecommons.org/licenses/by-nc/2.5/ * 
 **************************************************/

class lang implements module {
	static $languages = array(
		'pol' => 'pl',
		'pl' => 'pl',
		'p' => 'pl',
		
		'ang' => 'en',
		'a' => 'en',
		'eng' => 'en',
		'en' => 'en',
		'e' => 'en',
		
		'niem' => 'de',
		'nie' => 'de',
		'n' => 'de',
		'de' => 'de',
		'd' => 'de',
		
		
		
		'esp' => 'es',
		'es' => 'es',
		'hiszp' => 'es',
		'hisz' => 'es',
		'his' => 'es',
		'hi' => 'es',
		'h' => 'es',
		
		
	);
	
	static function register_cmd() {
		$return = array();
		
		foreach(self::$languages as $lang => $to) {
			foreach(self::$languages as $lang2 => $to2) {
				if($to2 != $to) {
					$return[$lang.$lang2] = 'cmd_translate';
				}
			}
			if(!$return[$lang]) {
				$return[$lang] = 'cmd_typo';
			}
		}
		
		return $return;
	}
	
	static function help($cmd=NULL) {
		if($cmd === NULL) {
			GGapi::putRichText('[J1][J2] ', TRUE);
			GGapi::putRichText('zdanie', FALSE, TRUE);
			GGapi::putRichText("\n".'   Tłumaczy zdanie z języka [J1] na język [J2] (pol, ang, nie, his)'."\n\n");
		}
		else
		{
			GGapi::putRichText('[J1][J2] ', TRUE);
			GGapi::putRichText('zdanie', FALSE, TRUE);
			GGapi::putRichText("\n".'   Przekłada ');
			GGapi::putRichText('zdanie', FALSE, TRUE);
			GGapi::putRichText(' z języka [J1] na język [J2]'."\n\n".'Dostępne języki: pol, ang, nie, his'."\n\n");
			GGapi::putRichText('Przykłady', FALSE, FALSE, TRUE);
			GGapi::putRichText("\n".'polang Dzień dobry'."\n".'angnie Good morning');
		}
	}
	
	static function cmd_typo($cmd, $args) {
		GGapi::putText('Wybrana komenda nie istnieje. Prawdopodobnie chodziło ci o jedną z komend językowych, których nazwy zapisywane są ');
		GGapi::putRichText('bez', TRUE);
		GGapi::putRichText(' spacji pomiędzy kodami języków (angpol, a nie ang pol).'."\n\n");
		GGapi::putRichText('Spróbuj:', FALSE, FALSE, TRUE);
		GGapi::putRichText("\n".$cmd.$args);
	}
	
	static function cmd_translate($cmd, $args) {
		if(empty($args)) {
			GGapi::putText('Podaj tekst do przetłumaczenia!');
			return FALSE;
		}
		
		foreach(self::$languages as $lang => $from) {
			if(substr($cmd, 0, strlen($lang)) == $lang) {
				$cmd = substr($cmd, strlen($lang));
				break;
			}
		}
		foreach(self::$languages as $lang => $to) {
			if($cmd == $lang) break;
		}
		
		$url = 'http://translate.google.com/translate_a/t?client=t&text='.urlencode($args).'&sl='.$from.'&tl='.$to.'&hl=pl&oe=utf-8';
		$data = @file_get_contents($url, 0, stream_context_create(array(
			'http' => array(
				'method' => 'GET',
			),
		)));
		
		if(!$data) {
			GGapi::putText('Błąd w systemie tłumaczącym. Przepraszamy.');
			return FALSE;
		}
		
		$data = jsarray::parse($data);
		
		if(!$data OR count($data)==0 OR count($data[1])==0) {
			$url = 'http://ajax.googleapis.com/ajax/services/language/translate?v=1.0&q='.urlencode($args).'&langpair='.$from.'%7C'.$to;
			$data = @file_get_contents($url, 0, stream_context_create(array(
				'http' => array(
					'method' => 'GET',
					'header' => 'Referer: http://3rdparty.local/translate'."\r\n",
				),
			)));
			if(!$data) {
				GGapi::putText('Błąd w systemie tłumaczącym. Przepraszamy.');
				return FALSE;
			}
			
			$data = @json_decode($data, TRUE);
			if(!$data) {
				GGapi::putText('Błąd w systemie tłumaczącym. Przepraszamy.');
				return FALSE;
			}
			
			if($data['responseStatus'] != 200) {
				GGapi::putText('Błąd w systemie tłumaczącym. Kod błędu: '.$data['responseStatus']."\n".$data['responseDetails']);
				return FALSE;
			}
			
			GGapi::putRichText('Tłumaczenie (by Google):', FALSE, FALSE, TRUE);
			GGapi::putRichText("\n".strtr($data['responseData']['translatedText'], array('ñ' => "ň")));
		}
		else
		{
			GGapi::putRichText('Słownik (by Google) - '.$data[0][0][1].':', FALSE, FALSE, TRUE);
			foreach($data[1] as $przyp) {
				GGapi::putRichText("\n".$przyp[0], FALSE, TRUE);
				foreach($przyp[1] as $term) {
					GGapi::putRichText("\n".'- '.$term);
				}
			}
		}
	}
}
?>